//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	A_KnightAttack
//
//==========================================================================

void A_KnightAttack(mobj_t* actor)
{
	if (!actor->target)
	{
		return;
	}
	if (P_CheckMeleeRange(actor))
	{
		DamageMobj(actor->target, actor, actor, HITDICE(3));
		StartSoundName(actor, "KnightAttack2");
		return;
	}
	// Throw axe
	StartSound(actor, actor->sound_attack);
	if (actor->type == MT_KNIGHTGHOST || P_Random() < 40)
	{ // Red axe
		SpawnMissile(actor, actor->target, MT_REDAXE);
		return;
	}
	// Green axe
	SpawnMissile(actor, actor->target, MT_KNIGHTAXE);
}

//==========================================================================
//
//	A_DripBlood
//
//==========================================================================

void A_DripBlood(mobj_t* actor)
{
	mobj_t*	mo;

	mo = P_SpawnMobj(
		actor->origin.x + (Random() - Random()) * 8.0,
		actor->origin.y + (Random() - Random()) * 8.0,
		actor->origin.z, MT_BLOOD);
	mo->velocity.x = (Random() - Random()) * 4.0 * 35.0;
	mo->velocity.y = (Random() - Random()) * 4.0 * 35.0;
	mo->flags2 |= MF2_LOGRAV;
}

